window.RongIMLib.RongIMClient.init("3argexb63s9ie");
// 连接状态监听器
window.RongIMClient.setConnectionStatusListener({
  onChanged: function (status) {
    console.log("status changed", status);
    switch (status) {
      case window.RongIMLib.ConnectionStatus.CONNECTING:
        break;
      case window.RongIMLib.ConnectionStatus.DISCONNECTED:
        break;
      case window.RongIMLib.ConnectionStatus.KICKED_OFFLINE_BY_OTHER_CLIENT:
      case window.RongIMLib.ConnectionStatus.DOMAIN_INCORRECT:
      case window.RongIMLib.ConnectionStatus.NETWORK_UNAVAILABLE:
        reconnect();
        // callbacks.error(status);
        break;
    }
  },
});

// 消息监听器
window.RongIMClient.setOnReceiveMessageListener({
  onReceived: function (message) {
    console.log(message);
  },
});

function reconnect() {
  var callback = {
    onSuccess: function (userId) {
      console.log("reconnect success. " + userId);
    },
    onTokenIncorrect: function () {
      console.log("token 无效");
    },
    onError: function () {
      reconnect();
    },
  };
  var config = {
    auto: true,
    url: "cdn.ronghub.com/RongIMLib-2.2.6.min.js?d=" + Date.now(),
    rate: [100, 1000, 3000, 6000, 10000],
  };
  window.RongIMClient.reconnect(callback, config);
}

export const initRongRTC = (options) => {
  return new window.RongRTC({
    RongIMLib: window.RongIMLib,
    ...options,
  });
};

export const connectIM = (token) => {
  return new Promise((resolve, reject) => {
    window.RongIMClient.connect(token, {
      onSuccess: (userId) => {
        console.log("connect success, userId:" + userId);
        resolve(userId);
      },
      onTokenIncorrect: () => {
        reject({ type: "token", msg: "token unvalid" });
        console.log("token unvalid");
      },
      onError: (errorCode) => {
        console.log(errorCode);
        reject({ type: "error", msg: errorCode });
      },
    });
  });
};
